package com.m2u.rsa.example;

import java.rmi.RemoteException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Properties;

import org.apache.log4j.Logger;

import com.m2u.rsa.helper.CommonHelper;
import com.m2u.rsa.helper.M2URSABean;
import com.m2u.rsa.helper.M2URSACfg;
import com.rsa.csd.ws.AdaptiveAuthenticationInterface;
import com.rsa.csd.ws.AnalyzeRequest;
import com.rsa.csd.ws.AnalyzeResponse;
import com.rsa.csd.ws.DeviceRequest;
import com.rsa.csd.ws.EventDataList;
import com.rsa.csd.ws.EventType;
import com.rsa.csd.ws.GenericActionType;
import com.rsa.csd.ws.GenericActionTypeList;
import com.rsa.csd.ws.IdentificationData;
import com.rsa.csd.ws.MessageHeader;
import com.rsa.csd.ws.RequestType;
import com.rsa.csd.ws.RiskResult;
import com.rsa.csd.ws.RunRiskType;
import com.rsa.csd.ws.SecurityHeader;
import com.rsa.csd.ws.SoapFaultType;
import com.rsa.csd.ws.StatusHeader;
import com.rsa.csd.ws.UserData;
import com.rsa.csd.ws.UserStatus;
import com.rsa.csd.ws.WSUserType;

public class AAAnalyze {

	private GenericActionTypeList GATL = new GenericActionTypeList();
	private DeviceRequest DR = new DeviceRequest();
	private IdentificationData ID = new IdentificationData();
	private MessageHeader MH = new MessageHeader();
	private SecurityHeader SH = new SecurityHeader();

	private UserData UD = new UserData();
	private EventDataList EDL = new EventDataList();
	private AnalyzeRequest AnalyzeReq = new AnalyzeRequest();

	private AnalyzeResponse AnalyzeRes = new AnalyzeResponse();
	private StatusHeader StatHead = new StatusHeader();
	private RiskResult RR = new RiskResult();

	private M2URSACfg cfg = M2URSACfg.getInstance();
	private Properties prop = new Properties();
	private static final Logger logger = Logger.getLogger(AAAnalyze.class
			.getName());

	public AAAnalyze() {

		M2URSABean bean = M2URSABean.getInstance();
		AdaptiveAuthenticationInterface invoker = bean.getInvoker();
		CommonHelper CHelp = new CommonHelper();

		Date now = new Date();
		SimpleDateFormat formatPattern = new SimpleDateFormat(
				"yyyy-MM-dd'T'HH:mm:ssz");
		String SDF = formatPattern.format(now);

		GenericActionType[] GAT = { GenericActionType.GET_USER_STATUS };
		GATL.setGenericActionTypes(GAT);

		DR = CHelp.setDevice("DP", "DTC", "FSO", "HA", "HAC", "HAE", "HAL",
				"HR", "171.25.31.166", "UA");
		ID = CHelp.setIdent(null, null, null, null, null, null, null, null,
				null, null, "RSATest2", "RSATest2", UserStatus.VERIFIED,
				WSUserType.PERSISTENT);
		MH = CHelp.setMessage("0000000001", RequestType.ANALYZE, SDF);
		SH = CHelp.setSecurityHeader();
		AnalyzeReq.setActionTypeList(GATL);
		AnalyzeReq.setDeviceRequest(DR);
		AnalyzeReq.setIdentificationData(ID);
		AnalyzeReq.setMessageHeader(MH);
		AnalyzeReq.setSecurityHeader(SH);

		/* For Analyze */

		EDL = CHelp.setEventData("Session Signin", EventType.SESSION_SIGNIN);
		AnalyzeReq.setEventDataList(EDL);

		AnalyzeReq.setRunRiskType(RunRiskType.ALL);

		// UD = CHelp.setUserData(business, lastAccountOpenDate,
		// lastOnlineServicePasswordChangeDate, onlineServiceEnrollDate,
		// totalAvailableBalance, totalCreditLimit, totalCreditsUsed,
		// userAddress, userNameData, VIP);

		try {
			cfg = M2URSACfg.getInstance();
			prop = cfg.getprop();

			if (prop.getProperty("SWITCH").matches("0")) {
				AnalyzeRes = invoker.analyze(AnalyzeReq);

				ID = AnalyzeRes.getIdentificationData();
				RR = AnalyzeRes.getRiskResult();

				StatHead = AnalyzeRes.getStatusHeader();

				String Desc = StatHead.getReasonDescription();
				Integer StatCode = StatHead.getStatusCode();
				Integer ReaCode = StatHead.getReasonCode();

				String SID = ID.getSessionId();
				String TID = ID.getTransactionId();
				UserStatus USTAT = ID.getUserStatus();

				RR = new RiskResult();
				RR = AnalyzeRes.getRiskResult();
				Integer RScore = RR.getRiskScore();
				String Act = RR.getTriggeredRule().getActionCode().toString();

				System.out.println("Status Code : " + StatCode);
				System.out.println("Reason Code : " + ReaCode);
				System.out.println("UserStatus : " + USTAT.getValue());
				System.out.println("Action : " + Act);
				System.out.println("Risk Score : " + RScore);
				System.out.println("SessionID : " + SID);
				System.out.println("TransactionID : " + TID);
				System.out.println("Description : " + Desc);

			} else if (prop.getProperty("SWITCH").matches("1")) {
				logger.info("Switch is Off");
			}
		} catch (SoapFaultType e) {
			// e.printStackTrace();
			System.out.println("ERROR1");

		} catch (RemoteException e) {
			// e.printStackTrace();
			logger.error("Connect Failure");

		} catch (Exception e) {
			System.out.println("ERROR3");
			System.out.println(e.getMessage());
		}
	}

}
