package com.m2u.rsa.example;

import java.rmi.RemoteException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Properties;

import org.apache.log4j.Logger;

import com.m2u.rsa.helper.CommonHelper;
import com.m2u.rsa.helper.M2URSABean;
import com.m2u.rsa.helper.M2URSACfg;
import com.rsa.csd.ws.AdaptiveAuthenticationInterface;
import com.rsa.csd.ws.AuthenticateRequest;
import com.rsa.csd.ws.AuthenticateResponse;
import com.rsa.csd.ws.AuthenticationResult;
import com.rsa.csd.ws.CallStatus;
import com.rsa.csd.ws.ChallengeQuestion;
import com.rsa.csd.ws.ChallengeQuestionAuthResult;
import com.rsa.csd.ws.ChallengeQuestionAuthResultPayload;
import com.rsa.csd.ws.ChallengeQuestionData;
import com.rsa.csd.ws.ChallengeQuestionDataPayload;
import com.rsa.csd.ws.CredentialAuthResultList;
import com.rsa.csd.ws.CredentialDataList;
import com.rsa.csd.ws.DeviceRequest;
import com.rsa.csd.ws.IdentificationData;
import com.rsa.csd.ws.MessageHeader;
import com.rsa.csd.ws.RequestType;
import com.rsa.csd.ws.SecurityHeader;
import com.rsa.csd.ws.SoapFaultType;
import com.rsa.csd.ws.StatusHeader;
import com.rsa.csd.ws.UserData;
import com.rsa.csd.ws.UserStatus;
import com.rsa.csd.ws.WSUserType;

public class AAAuthenticate {

	private DeviceRequest DR = new DeviceRequest();
	private IdentificationData ID = new IdentificationData();
	private MessageHeader MH = new MessageHeader();
	private SecurityHeader SH = new SecurityHeader();

	private UserData UD = new UserData();
	private AuthenticateRequest AReq = new AuthenticateRequest();

	private AuthenticateResponse ARes = new AuthenticateResponse();
	private StatusHeader StatHead = new StatusHeader();

	private M2URSACfg cfg = M2URSACfg.getInstance();
	private Properties prop = new Properties();
	private static final Logger logger = Logger.getLogger(AAAuthenticate.class
			.getName());

	public AAAuthenticate() {
		M2URSABean bean = M2URSABean.getInstance();
		AdaptiveAuthenticationInterface invoker = bean.getInvoker();
		CommonHelper CHelp = new CommonHelper();

		Date now = new Date();
		SimpleDateFormat formatPattern = new SimpleDateFormat(
				"yyyy-MM-dd'T'HH:mm:ssz");
		String SDF = formatPattern.format(now);

		DR = CHelp.setDevice("DP", "DTC", "FSO", "HA", "HAC", "HAE", "HAL",
				"HR", "172.25.30.166", "UA");
		ID = CHelp.setIdent(null, null, null, null, null, null,
				"-5533e0c5:1295839d60c:-7fdf",
				"TRX_-5533e0c5:1295839d60c:-7fde", null, null, "M2UTest1",
				"RSATest1", UserStatus.VERIFIED, WSUserType.PERSISTENT);
		MH = CHelp.setMessage("0000000001", RequestType.AUTHENTICATE, SDF);
		SH = CHelp.setSecurityHeader();

		// UD = CHelp.setUserData(business, lastAccountOpenDate,
		// lastOnlineServicePasswordChangeDate, onlineServiceEnrollDate,
		// totalAvailableBalance, totalCreditLimit, totalCreditsUsed,
		// userAddress, userNameData, VIP)

		AReq.setDeviceRequest(DR);
		AReq.setIdentificationData(ID);
		AReq.setMessageHeader(MH);
		AReq.setSecurityHeader(SH);

		CredentialDataList CDL = new CredentialDataList();
		ChallengeQuestionData CQD = new ChallengeQuestionData();
		ChallengeQuestionDataPayload CQDP = new ChallengeQuestionDataPayload();
		ChallengeQuestion QC1 = new ChallengeQuestion();
		QC1.setQuestionId("Q1.2");
		QC1.setUserAnswer("three");
		ChallengeQuestion[] QC = { QC1 };
		CQDP.setChallengeQuestion(QC);
		CQD.setPayload(CQDP);
		CDL.setChallengeQuestionData(CQD);
		AReq.setCredentialDataList(CDL);

		try {
			cfg = M2URSACfg.getInstance();
			prop = cfg.getprop();

			if (prop.getProperty("SWITCH").matches("0")) {
				ARes = invoker.authenticate(AReq);

				StatHead = ARes.getStatusHeader();

				String Desc = StatHead.getReasonDescription();
				Integer StatCode = StatHead.getStatusCode();
				Integer ReaCode = StatHead.getReasonCode();

				System.out.println("Status Code : " + StatCode);
				System.out.println("Reason Code : " + ReaCode);
				System.out.println("Description : " + Desc);

				CredentialAuthResultList CARL = ARes
						.getCredentialAuthResultList();
				ChallengeQuestionAuthResult CQAR = CARL
						.getChallengeQuestionAuthResult();
				ChallengeQuestionAuthResultPayload CQAP = CQAR.getPayload();
				CallStatus CS = CQAP.getCallStatus();
				System.out.println(CS.getStatusCode());
				AuthenticationResult AR = CQAP.getAuthenticationResult();
				System.out.println(AR.getAuthStatusCode());
				System.out.println(AR.getRisk());
			} else if (prop.getProperty("SWITCH").matches("1")) {
				logger.info("Switch is Off");
			}

		} catch (SoapFaultType e) {
			// e.printStackTrace();
			System.out.println("ERROR1");

		} catch (RemoteException e) {
			// e.printStackTrace();
			System.out.println("ERROR2");

		} catch (Exception e) {
			System.out.println("ERROR3");
		}

	}

}
