package com.m2u.rsa.example;

import java.rmi.RemoteException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Properties;

import org.apache.log4j.Logger;

import com.m2u.rsa.helper.CommonHelper;
import com.m2u.rsa.helper.M2URSABean;
import com.m2u.rsa.helper.M2URSACfg;
import com.rsa.csd.ws.AdaptiveAuthenticationInterface;
import com.rsa.csd.ws.BindingType;
import com.rsa.csd.ws.CreateUserRequest;
import com.rsa.csd.ws.CreateUserResponse;
import com.rsa.csd.ws.DeviceActionType;
import com.rsa.csd.ws.DeviceActionTypeList;
import com.rsa.csd.ws.DeviceData;
import com.rsa.csd.ws.DeviceManagementRequestPayload;
import com.rsa.csd.ws.DeviceRequest;
import com.rsa.csd.ws.GenericActionType;
import com.rsa.csd.ws.GenericActionTypeList;
import com.rsa.csd.ws.IdentificationData;
import com.rsa.csd.ws.MessageHeader;
import com.rsa.csd.ws.RequestType;
import com.rsa.csd.ws.RiskResult;
import com.rsa.csd.ws.RunRiskType;
import com.rsa.csd.ws.SecurityHeader;
import com.rsa.csd.ws.SoapFaultType;
import com.rsa.csd.ws.StatusHeader;
import com.rsa.csd.ws.UserData;
import com.rsa.csd.ws.UserStatus;
import com.rsa.csd.ws.WSUserType;

public class AACreate {
	/* Common */
	private DeviceRequest DR = new DeviceRequest();
	private IdentificationData ID = new IdentificationData();
	private MessageHeader MH = new MessageHeader();
	private SecurityHeader SH = new SecurityHeader();

	/* Inherent */
	private CreateUserRequest CUReq = new CreateUserRequest();

	private GenericActionTypeList GATL = new GenericActionTypeList();
	private UserData UD = new UserData();

	private CreateUserResponse CURes = new CreateUserResponse();
	private StatusHeader StatHead = new StatusHeader();

	private M2URSACfg cfg = M2URSACfg.getInstance();
	private Properties prop = new Properties();
	private static final Logger logger = Logger.getLogger(AACreate.class
			.getName());

	public AACreate() {
		M2URSABean bean = M2URSABean.getInstance();
		AdaptiveAuthenticationInterface invoker = bean.getInvoker();
		CommonHelper CHelp = new CommonHelper();

		Date now = new Date();
		SimpleDateFormat formatPattern = new SimpleDateFormat(
				"yyyy-MM-dd'T'HH:mm:ssz");
		String SDF = formatPattern.format(now);

		GenericActionType[] GAT = { GenericActionType.SET_USER_STATUS };
		GATL = CHelp.setGenericActionType(GAT);

		// CH = CHelp.setConfHead("Maybank2u", null, null);

		/* Common to ALL Method */
		DR = CHelp.setDevice("DP", "DTC", "FSO", "HA", "HAC", "HAE", "HAL",
				"HR", "172.25.30.166", "UA");
		ID = CHelp.setIdent(null, null, null, null, null, null, null, null,
				null, null, "M2UTest20", "RSATest20", UserStatus.VERIFIED,
				WSUserType.PERSISTENT);
		MH = CHelp.setMessage("0000000001", RequestType.CREATEUSER, SDF);
		SH = CHelp.setSecurityHeader();

		CUReq.setActionTypeList(GATL);
		CUReq.setDeviceRequest(DR);
		CUReq.setIdentificationData(ID);
		CUReq.setMessageHeader(MH);
		CUReq.setSecurityHeader(SH);

		/* For Create only */
		DeviceManagementRequestPayload DMReqP = new DeviceManagementRequestPayload();
		DeviceData DD = new DeviceData();
		DD.setBindingType(BindingType.HARD_BIND);
		DMReqP.setDeviceData(DD);
		DeviceActionTypeList DATL = new DeviceActionTypeList();
		DeviceActionType[] DAT = { DeviceActionType.UPDATE_DEVICE };
		DATL.setDeviceActionTypes(DAT);
		DMReqP.setActionTypeList(DATL);

		CUReq.setDeviceManagementRequest(DMReqP);
		CUReq.setRunRiskType(RunRiskType.ALL);

		// First Time Login
		// UD = CHelp.setUserData(business, lastAccountOpenDate,
		// lastOnlineServicePasswordChangeDate, onlineServiceEnrollDate,
		// totalAvailableBalance, totalCreditLimit, totalCreditsUsed,
		// userAddress, userNameData, VIP)
		// CUReq.setUserData(UD);

		try {
			cfg = M2URSACfg.getInstance();
			prop = cfg.getprop();

			if (prop.getProperty("SWITCH").matches("0")) {
				CURes = invoker.createUser(CUReq);

				StatHead = CURes.getStatusHeader();

				String Desc = StatHead.getReasonDescription();
				Integer StatCode = StatHead.getStatusCode();
				Integer ReaCode = StatHead.getReasonCode();

				RiskResult RR = new RiskResult();
				RR = CURes.getRiskResult();
				Integer RScore = RR.getRiskScore();
				String Act = RR.getTriggeredRule().getActionCode().toString();

				System.out.println("Status Code : " + StatCode);
				System.out.println("Reason Code : " + ReaCode);
				System.out.println("Action : " + Act);
				System.out.println("Risk Score : " + RScore);
				System.out.println("Description : " + Desc);
			} else if (prop.getProperty("SWITCH").matches("1")) {
				logger.info("Switch is Off");
			}

		} catch (SoapFaultType e) {
			// e.printStackTrace();
			System.out.println("ERROR1");

		} catch (RemoteException e) {
			// e.printStackTrace();
			System.out.println("ERROR2");

		} catch (Exception e) {
			System.out.println("ERROR3");
		}

	}

}
