package com.m2u.rsa.example;

import java.rmi.RemoteException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Properties;

import org.apache.log4j.Logger;

import com.m2u.rsa.helper.CommonHelper;
import com.m2u.rsa.helper.M2URSABean;
import com.m2u.rsa.helper.M2URSACfg;
import com.rsa.csd.ws.AdaptiveAuthenticationInterface;
import com.rsa.csd.ws.DeviceRequest;
import com.rsa.csd.ws.EventDataList;
import com.rsa.csd.ws.EventType;
import com.rsa.csd.ws.GenericActionType;
import com.rsa.csd.ws.GenericActionTypeList;
import com.rsa.csd.ws.IdentificationData;
import com.rsa.csd.ws.MessageHeader;
import com.rsa.csd.ws.NotifyRequest;
import com.rsa.csd.ws.NotifyResponse;
import com.rsa.csd.ws.RequestType;
import com.rsa.csd.ws.SecurityHeader;
import com.rsa.csd.ws.SoapFaultType;
import com.rsa.csd.ws.StatusHeader;
import com.rsa.csd.ws.UserData;
import com.rsa.csd.ws.UserStatus;
import com.rsa.csd.ws.WSUserType;

public class AANotify {

	private GenericActionTypeList GATL = new GenericActionTypeList();

	private DeviceRequest DR = new DeviceRequest();
	private IdentificationData ID = new IdentificationData();
	private MessageHeader MH = new MessageHeader();
	private SecurityHeader SH = new SecurityHeader();

	private UserData UD = new UserData();
	private EventDataList EDL = new EventDataList();

	private NotifyRequest NotifyReq = new NotifyRequest();

	private NotifyResponse NotifyRes = new NotifyResponse();
	private StatusHeader StatHead = new StatusHeader();

	private M2URSACfg cfg = M2URSACfg.getInstance();
	private Properties prop = new Properties();
	private static final Logger logger = Logger.getLogger(AANotify.class
			.getName());

	public AANotify() {
		M2URSABean bean = M2URSABean.getInstance();
		AdaptiveAuthenticationInterface invoker = bean.getInvoker();
		CommonHelper CHelp = new CommonHelper();

		Date now = new Date();
		SimpleDateFormat formatPattern = new SimpleDateFormat(
				"yyyy-MM-dd'T'HH:mm:ssz");
		String SDF = formatPattern.format(now);

		GenericActionType[] GAT = { GenericActionType.SET_USER_STATUS };
		GATL = CHelp.setGenericActionType(GAT);
		NotifyReq.setActionTypeList(GATL);

		DR = CHelp.setDevice("DP", "DTC", "FSO", "HA", "HAC", "HAE", "HAL",
				"HR", "172.25.30.166", "UA");
		ID = CHelp.setIdent(null, null, null, null, null, null, null, null,
				null, null, "M2UTest2", "RSATest2", UserStatus.VERIFIED,
				WSUserType.PERSISTENT);
		MH = CHelp.setMessage("0000000001", RequestType.NOTIFY, SDF);
		SH = CHelp.setSecurityHeader();

		NotifyReq.setDeviceRequest(DR);
		NotifyReq.setIdentificationData(ID);
		NotifyReq.setMessageHeader(MH);
		NotifyReq.setSecurityHeader(SH);

		// NotifyReq.setAutoCreateUserFlag(new Boolean("TRUE"));
		// NotifyReq.setChannelIndicator(ChannelIndicatorType.WEB);
		// NotifyReq.setClientDefinedChannelIndicator("M2U");

		EDL = CHelp.setEventData("Password Change", EventType.CHANGE_PASSWORD);
		NotifyReq.setEventDataList(EDL);

		try {
			cfg = M2URSACfg.getInstance();
			prop = cfg.getprop();

			if (prop.getProperty("SWITCH").matches("0")) {
				NotifyRes = invoker.notify(NotifyReq);

				StatHead = NotifyRes.getStatusHeader();

				String Desc = StatHead.getReasonDescription();
				Integer StatCode = StatHead.getStatusCode();
				Integer ReaCode = StatHead.getReasonCode();

				System.out.println("Status Code : " + StatCode);
				System.out.println("Reason Code : " + ReaCode);
				System.out.println("Description : " + Desc);
				System.out.println("Done");
			} else if (prop.getProperty("SWITCH").matches("1")) {
				logger.info("Switch is Off");
			}
		} catch (SoapFaultType e) {
			// e.printStackTrace();
			System.out.println("ERROR1");

		} catch (RemoteException e) {
			// e.printStackTrace();
			System.out.println("ERROR2");

		} catch (Exception e) {
			System.out.println("ERROR3");
		}

	}
}
