package com.m2u.rsa.example;

import java.rmi.RemoteException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Properties;

import org.apache.log4j.Logger;

import com.m2u.rsa.helper.CommonHelper;
import com.m2u.rsa.helper.M2URSABean;
import com.m2u.rsa.helper.M2URSACfg;
import com.rsa.csd.ws.AdaptiveAuthenticationInterface;
import com.rsa.csd.ws.BrowsableImages;
import com.rsa.csd.ws.Category;
import com.rsa.csd.ws.ChallengeQuestion;
import com.rsa.csd.ws.ChallengeQuestionActionType;
import com.rsa.csd.ws.ChallengeQuestionActionTypeList;
import com.rsa.csd.ws.ChallengeQuestionGroup;
import com.rsa.csd.ws.ChallengeQuestionGroupList;
import com.rsa.csd.ws.ChallengeQuestionManagementRequest;
import com.rsa.csd.ws.ChallengeQuestionManagementRequestPayload;
import com.rsa.csd.ws.ChallengeQuestionManagementResponse;
import com.rsa.csd.ws.ChallengeQuestionManagementResponsePayload;
import com.rsa.csd.ws.CredentialManagementRequestList;
import com.rsa.csd.ws.CredentialManagementResponseList;
import com.rsa.csd.ws.GenericActionType;
import com.rsa.csd.ws.GenericActionTypeList;
import com.rsa.csd.ws.IdentificationData;
import com.rsa.csd.ws.Image;
import com.rsa.csd.ws.MessageHeader;
import com.rsa.csd.ws.QueryRequest;
import com.rsa.csd.ws.QueryResponse;
import com.rsa.csd.ws.RequestType;
import com.rsa.csd.ws.SecurityHeader;
import com.rsa.csd.ws.SiteToUserBrowseResponse;
import com.rsa.csd.ws.SoapFaultType;
import com.rsa.csd.ws.StatusHeader;
import com.rsa.csd.ws.UserStatus;
import com.rsa.csd.ws.WSUserType;

public class AAQuery {

	private IdentificationData ID = new IdentificationData();
	private MessageHeader MH = new MessageHeader();
	private SecurityHeader SH = new SecurityHeader();
	private GenericActionTypeList GATL = new GenericActionTypeList();
	private QueryRequest QReq = new QueryRequest();
	private QueryResponse QRes = new QueryResponse();
	private StatusHeader StatHead = new StatusHeader();

	private M2URSACfg cfg = M2URSACfg.getInstance();
	private Properties prop = new Properties();
	private static final Logger logger = Logger.getLogger(AAQuery.class
			.getName());

	public AAQuery() {

		M2URSABean bean = M2URSABean.getInstance();
		AdaptiveAuthenticationInterface invoker = bean.getInvoker();
		CommonHelper CHelp = new CommonHelper();

		Date now = new Date();
		SimpleDateFormat formatPattern = new SimpleDateFormat(
				"yyyy-MM-dd'T'HH:mm:ssz");
		String SDF = formatPattern.format(now);

		GenericActionType[] GAT = { GenericActionType.BROWSE_CATEGORIES,
				GenericActionType.BROWSE_IMAGES };
		GATL = CHelp.setGenericActionType(GAT);

		ID = CHelp.setIdent(null, null, null, null, null, null, null, null,
				null, null, "M2UTest1", "RSATest1", UserStatus.VERIFIED,
				WSUserType.PERSISTENT);
		MH = CHelp.setMessage("0000000001", RequestType.QUERY, SDF);
		SH = CHelp.setSecurityHeader();
		QReq.setActionTypeList(GATL);
		QReq.setIdentificationData(ID);
		QReq.setMessageHeader(MH);
		QReq.setSecurityHeader(SH);

		CredentialManagementRequestList CMReqL = new CredentialManagementRequestList();
		ChallengeQuestionManagementRequest CQMReq = new ChallengeQuestionManagementRequest();
		ChallengeQuestionManagementRequestPayload CQMReqP = new ChallengeQuestionManagementRequestPayload();
		ChallengeQuestionActionTypeList CQATL = new ChallengeQuestionActionTypeList();

		ChallengeQuestionActionType[] CQAT = { ChallengeQuestionActionType.BROWSE_QUESTION };
		CQATL.setChallengeQuestionActionType(CQAT);
		CQMReqP.setActionTypeList(CQATL);
		CQMReq.setPayload(CQMReqP);
		CMReqL.setChallengeQuestionManagementRequest(CQMReq);
		QReq.setCredentialManagementRequestList(CMReqL);

		try {
			cfg = M2URSACfg.getInstance();
			prop = cfg.getprop();

			if (prop.getProperty("SWITCH").matches("0")) {
				QRes = invoker.query(QReq);

				StatHead = QRes.getStatusHeader();

				String Desc = StatHead.getReasonDescription();
				Integer StatCode = StatHead.getStatusCode();
				Integer ReaCode = StatHead.getReasonCode();

				System.out.println("Status Code : " + StatCode);
				System.out.println("Reason Code : " + ReaCode);
				System.out.println("Description : " + Desc);

				SiteToUserBrowseResponse SUBR = QRes
						.getSiteToUserBrowseResponse();
				Category category[] = SUBR.getBrowseableImageCategories();

				BrowsableImages BI = SUBR.getBrowsableImages();
				Image image[] = BI.getImage();
				int nImg = image.length;
				int nCat = category.length;

				System.out.println("CATEGORIES");
				for (int x = 0; x < nCat; x++) {
					System.out.println(category[x].getCategoryDisplayName());
					// System.out.println(category[x].getCategoryKey());
				}
				System.out.println("**************************");
				System.out.println("IMAGES");
				for (int y = 0; y < nImg; y++) {
					System.out.println(image[y].getPath());
					System.out.println(image[y].getAltText());
				}
				System.out.println("**************************");

				CredentialManagementResponseList CMResL = QRes
						.getCredentialManagementResponseList();
				ChallengeQuestionManagementResponse CQMRes = CMResL
						.getChallengeQuestionManagementResponse();
				ChallengeQuestionManagementResponsePayload CQMResP = CQMRes
						.getPayload();
				ChallengeQuestionGroupList CQGL = CQMResP
						.getBrowsableChallQuesGroupList();
				ChallengeQuestionGroup CQG[] = CQGL.getQuestionGroup();
				int nCQG = CQG.length;

				for (int z = 0; z < nCQG; z++) {
					ChallengeQuestion CQ[] = CQG[z].getChallengeQuestion();
					int nCQ = CQ.length;
					for (int a = 0; a < nCQ; a++) {
						System.out.println(CQ[a].getQuestionId());
						System.out.println(CQ[a].getQuestionText());
					}

				}

				System.out.println("Done");
			} else if (prop.getProperty("SWITCH").matches("1")) {
				logger.info("Switch is Off");
			}
		} catch (SoapFaultType e) {
			// e.printStackTrace();
			System.out.println("ERROR1");

		} catch (RemoteException e) {
			e.printStackTrace();

		} catch (Exception e) {
			System.out.println("ERROR3");
		}

	}
}
