package com.m2u.rsa.example;

import java.rmi.RemoteException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Properties;

import org.apache.log4j.Logger;

import com.m2u.rsa.helper.CommonHelper;
import com.m2u.rsa.helper.M2URSABean;
import com.m2u.rsa.helper.M2URSACfg;
import com.rsa.csd.ws.AdaptiveAuthenticationInterface;
import com.rsa.csd.ws.BindingType;
import com.rsa.csd.ws.CallStatus;
import com.rsa.csd.ws.ChallengeQuestion;
import com.rsa.csd.ws.ChallengeQuestionActionType;
import com.rsa.csd.ws.ChallengeQuestionActionTypeList;
import com.rsa.csd.ws.ChallengeQuestionList;
import com.rsa.csd.ws.ChallengeQuestionManagementRequest;
import com.rsa.csd.ws.ChallengeQuestionManagementRequestPayload;
import com.rsa.csd.ws.ChallengeQuestionManagementResponse;
import com.rsa.csd.ws.ChallengeQuestionManagementResponsePayload;
import com.rsa.csd.ws.ConfigurationHeader;
import com.rsa.csd.ws.CredentialManagementRequestList;
import com.rsa.csd.ws.CredentialManagementResponseList;
import com.rsa.csd.ws.DeviceActionType;
import com.rsa.csd.ws.DeviceActionTypeList;
import com.rsa.csd.ws.DeviceData;
import com.rsa.csd.ws.DeviceManagementRequestPayload;
import com.rsa.csd.ws.DeviceRequest;
import com.rsa.csd.ws.EventData;
import com.rsa.csd.ws.EventDataList;
import com.rsa.csd.ws.EventType;
import com.rsa.csd.ws.GenericActionType;
import com.rsa.csd.ws.GenericActionTypeList;
import com.rsa.csd.ws.IdentificationData;
import com.rsa.csd.ws.Image;
import com.rsa.csd.ws.MessageHeader;
import com.rsa.csd.ws.RequestType;
import com.rsa.csd.ws.RunRiskType;
import com.rsa.csd.ws.SecurityHeader;
import com.rsa.csd.ws.SiteToUserData;
import com.rsa.csd.ws.SoapFaultType;
import com.rsa.csd.ws.StatusHeader;
import com.rsa.csd.ws.UpdateUserRequest;
import com.rsa.csd.ws.UpdateUserResponse;
import com.rsa.csd.ws.UserData;
import com.rsa.csd.ws.UserStatus;
import com.rsa.csd.ws.WSUserType;

public class AAUpdateUser {
	private GenericActionTypeList GATL = new GenericActionTypeList();
	private ConfigurationHeader CH = new ConfigurationHeader();
	private DeviceRequest DR = new DeviceRequest();
	private IdentificationData ID = new IdentificationData();
	private MessageHeader MH = new MessageHeader();
	private SecurityHeader SH = new SecurityHeader();

	private UserData UD = new UserData();

	private UpdateUserRequest UUReq = new UpdateUserRequest();
	private UpdateUserResponse UURes = new UpdateUserResponse();

	private StatusHeader StatHead = new StatusHeader();

	private M2URSACfg cfg = M2URSACfg.getInstance();
	private Properties prop = new Properties();
	private static final Logger logger = Logger.getLogger(AAUpdateUser.class
			.getName());

	public AAUpdateUser() {
		M2URSABean bean = M2URSABean.getInstance();
		AdaptiveAuthenticationInterface invoker = bean.getInvoker();
		CommonHelper CHelp = new CommonHelper();

		Date now = new Date();
		SimpleDateFormat formatPattern = new SimpleDateFormat(
				"yyyy-MM-dd'T'HH:mm:ssz");
		String SDF = formatPattern.format(now);

		/* Common to ALL Method */
		GenericActionType[] GAT = { GenericActionType.SET_USER_STATUS };
		GATL.setGenericActionTypes(GAT);
		DR = CHelp.setDevice("DP", "DTC", "FSO", "HA", "HAC", "HAE", "HAL",
				"HR", "172.25.30.166", "UA");
		ID = CHelp.setIdent(null, null, null, null, null, null, null, null,
				null, null, "M2UTest2", "RSATest2", UserStatus.VERIFIED,
				WSUserType.PERSISTENT);
		MH = CHelp.setMessage("0000000001", RequestType.UPDATEUSER, SDF);
		SH = CHelp.setSecurityHeader();

		UUReq.setActionTypeList(GATL);
		UUReq.setConfigurationHeader(CH);
		UUReq.setDeviceRequest(DR);
		UUReq.setIdentificationData(ID);
		UUReq.setMessageHeader(MH);
		UUReq.setSecurityHeader(SH);
		UUReq.setRunRiskType(RunRiskType.ALL);

		/* UpdateUser */

		CredentialManagementRequestList CMRL = new CredentialManagementRequestList();
		ChallengeQuestionManagementRequest CQMR = new ChallengeQuestionManagementRequest();
		// CQMR.setCredentialProvisioningStatus(CredentialProvisioningStatus.ACTIVE);
		ChallengeQuestionManagementRequestPayload payload = new ChallengeQuestionManagementRequestPayload();
		ChallengeQuestionActionTypeList CQATL = new ChallengeQuestionActionTypeList();
		ChallengeQuestionActionType[] CQAT = { ChallengeQuestionActionType.SET_USER_QUESTION };
		CQATL.setChallengeQuestionActionType(CQAT);
		payload.setActionTypeList(CQATL);

		ChallengeQuestionList CQL = new ChallengeQuestionList();
		ChallengeQuestion CQ1 = new ChallengeQuestion();
		ChallengeQuestion CQ2 = new ChallengeQuestion();
		ChallengeQuestion CQ3 = new ChallengeQuestion();
		CQ1.setActualAnswer("three");
		CQ1.setQuestionId("Q1.1");
		// CQ1.setQuestionText("questionText1");
		CQ2.setActualAnswer("three");
		CQ2.setQuestionId("Q1.2");
		// CQ2.setQuestionText("questionText2");
		CQ3.setActualAnswer("three");
		CQ3.setQuestionId("Q1.3");
		// CQ3.setQuestionText("questionText3");

		ChallengeQuestion[] CQuest = { CQ1, CQ2, CQ3 };
		CQL.setChallengeQuestion(CQuest);
		payload.setChallengeQuestionList(CQL);

		CQMR.setPayload(payload);
		CMRL.setChallengeQuestionManagementRequest(CQMR);
		UUReq.setCredentialManagementRequestList(CMRL);

		DeviceManagementRequestPayload DMReqP = new DeviceManagementRequestPayload();
		DeviceData DD = new DeviceData();
		DD.setBindingType(BindingType.HARD_BIND);
		DMReqP.setDeviceData(DD);
		DeviceActionTypeList DATL = new DeviceActionTypeList();
		DeviceActionType[] DAT = { DeviceActionType.UPDATE_DEVICE };
		DATL.setDeviceActionTypes(DAT);
		DMReqP.setActionTypeList(DATL);
		UUReq.setDeviceManagementRequest(DMReqP);

		SiteToUserData STUD = new SiteToUserData();
		STUD.setPhrase("phrase");
		Image Img = new Image();
		Img.setAltText("altText");
		// Img.setData("data");
		// Img.setHeight("height");
		Img.setImageId("imageId");
		Img.setPath("path");
		// Img.setWidth("width");
		STUD.setUserImage(Img);
		UUReq.setSiteToUserData(STUD);

		// When Info Changes
		// UD = CHelp.setUserData(business, lastAccountOpenDate,
		// lastOnlineServicePasswordChangeDate, onlineServiceEnrollDate,
		// totalAvailableBalance, totalCreditLimit, totalCreditsUsed,
		// userAddress, userNameData, VIP)

		EventDataList EDL = new EventDataList();
		EventData ED = new EventData();
		ED.setEventType(EventType.UPDATE_USER);
		EventData[] ee = { ED };
		EDL.setEventData(ee);
		UUReq.setEventDataList(EDL);

		try {
			cfg = M2URSACfg.getInstance();
			prop = cfg.getprop();

			if (prop.getProperty("SWITCH").matches("0")) {

				UURes = invoker.updateUser(UUReq);
				StatHead = UURes.getStatusHeader();
				Integer StatCode = StatHead.getStatusCode();
				Integer ReaCode = StatHead.getReasonCode();
				String Desc = StatHead.getReasonDescription();

				System.out.println("Status Code : " + StatCode);
				System.out.println("Reason Code : " + ReaCode);
				System.out.println("Description : " + Desc);

				CredentialManagementResponseList CMResL = UURes
						.getCredentialManagementResponseList();
				ChallengeQuestionManagementResponse CQMRes = CMResL
						.getChallengeQuestionManagementResponse();
				ChallengeQuestionManagementResponsePayload CQMResP = CQMRes
						.getPayload();
				CallStatus CS = CQMResP.getCallStatus();

				System.out.println(CS.getStatusCode());
			} else if (prop.getProperty("SWITCH").matches("1")) {
				logger.info("Switch is Off");
			}
		} catch (SoapFaultType e) {
			// e.printStackTrace();
			System.out.println("ERROR1");

		} catch (RemoteException e) {
			// e.printStackTrace();
			System.out.println("ERROR2");

		} catch (Exception e) {
			System.out.println("ERROR3");
		}

	}

}
