package com.m2u.rsa.helper;

import java.net.URL;
import java.util.Properties;

import org.apache.axis.AxisProperties;
import org.apache.log4j.Logger;

import com.rsa.csd.ws.AdaptiveAuthenticationInterface;
import com.rsa.csd.ws.AdaptiveAuthenticationLocator;

public class M2URSABean implements java.io.Serializable {
	private static final long serialVersionUID = 293717904705765947L;
	AdaptiveAuthenticationLocator locator = new AdaptiveAuthenticationLocator();
	AdaptiveAuthenticationInterface invoker = null;
	private static M2URSABean instance = null;
	Properties prop = new Properties();
	private static final Logger logger = Logger.getLogger(M2URSABean.class
			.getName());

	protected M2URSABean() {
		try {

			M2URSACfg cfg = M2URSACfg.getInstance();
			prop = cfg.getprop();

			String wsdl = prop.getProperty("WSDL");
			URL defUrl = new URL(wsdl);

			locator = new AdaptiveAuthenticationLocator();
			invoker = locator.getAdaptiveAuthentication(defUrl);
			AxisProperties.setProperty("axis.socketSecureFactory",
					"org.apache.axis.components.net.SunFakeTrustSocketFactory");

		} catch (Exception e) {
			logger.error(e.getStackTrace());
		}

	}

	public static M2URSABean getInstance() {
		if (instance == null) {
			instance = new M2URSABean();
		}
		return instance;
	}

	public AdaptiveAuthenticationInterface getInvoker() {
		return invoker;

	}

}
