package com.m2u.rsa.helper;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

import org.apache.log4j.Logger;

public class M2URSACfg implements java.io.Serializable {
	private static final long serialVersionUID = -5343918238318614628L;
	private static final Logger logger = Logger.getLogger(M2URSACfg.class
			.getName());
	private static M2URSACfg instance = null;
	private Properties props = new Properties();

	protected M2URSACfg() {
		try {
			String curDir = System.getProperty("user.dir");
			FileInputStream in = new FileInputStream(curDir + File.separator
					+ "m2ursacfg.cfg");
			/*
			 * FileInputStream in = new FileInputStream(curDir + File.separator
			 * + "bv1to1_var" + File.separator + "etc" + File.separator +
			 * "m2ursa.cfg");
			 */
			props.load(in);
			in.close();
		} catch (FileNotFoundException fnfe) {
			logger.error("M2URSACfg Error: " + fnfe.getMessage());
		} catch (IOException ioe) {
			logger.error("M2URSACfg Error: " + ioe.getMessage());
		}
	}

	public static M2URSACfg getInstance() {
		if (instance == null) {
			instance = new M2URSACfg();
		}
		return instance;
	}

	public Properties getprop() {
		return props;
	}
}
